#include <bits/stdc++.h>

using namespace std;

int Xordel(int d)
{
    int x = 1;
    for(int i = 2; i <= d; i++)
    {
        if(d % i == 0)
            x ^= i;
    }
    return x;
}

int main()
{
    int n, k;
    cin >> n >> k;
    vector<int> d(k, 0);
    for(int i = 0; i < k; i++)
    {
        cin >> n;
        d[i] = n;
    }
    for(auto x:d)
        cout << Xordel(x) << " ";
    return 0;
}